/* file_struct - File de positions
 * ----------------------------------------------------------------------------
 * Ce fichier contient la declaration de la structure file, et des fonctions pour
 * la manipuler. Cette structure sert pour l'affichage des dernieres positions
 * du joueur. On peut :
 *   - Initialiser la file
 *   - Enfiler une valeur
 *   - Defiler une valeur	
 */


#include "file_struct.h"

/* Initialise la file
 *  ind  : ind max du tableau
 *  coup : nombre d'enregistrement cumule
 *   num : numero d'identification
 */
void init_file_struct(struct file_struct* telleFile,int telNum)
{
	telleFile->ind=AFF_MAX-1;
	telleFile->coup=0;
	telleFile->num=telNum;
}

/* Enfile les coordonnees x y dans la file
 * La file est geree de facon circulaire.
 * Les enregistrements commencent par la fin.
 * Lorsque l'indice est -1 est plein on ecrit a
 * l'indice max.
 */
void enfiler(struct file_struct* telleFile, int x, int y)
{
	telleFile->tab[telleFile->ind].x=x;
	telleFile->tab[telleFile->ind].y=y;

	telleFile->ind--;
	telleFile->coup++;

	if(telleFile->ind==-1)
		telleFile->ind=AFF_MAX-1;
}

/* Sort les coordonnees de l'indice courant et decremente
 * l'indice. Si cet indice est -1, on lui affecte l'indice
 * maximal du tableau
 */
void defiler(struct file_struct* telleFile,struct coord* telCoor)
{
	int indice;

	indice=telleFile->ind;

	if(telleFile->ind==-1)
		telleFile->ind=AFF_MAX-1;

	telCoor->x=telleFile->tab[indice].x;
	telCoor->y=telleFile->tab[indice].y;
}

