#include "stdio.h"
#include "stdlib.h"
#include "math.h"


int etat(int N, int L, int i, int j)
{
	int R1 = N/2-1;
	int R2 = R1-L;
	int route;
	double d;

	d = sqrt((i-N/2)*(i-N/2) + (j-N/2)*(j-N/2));
	route = (d<R1) && (d>R2);
	
	if (route && (i==N/2) && (j<N/2)) return 2;
	else return route;
}

void genere_fichier(int N, int L)
{
	char nom[30];
	FILE *F;
	int i,j;

	sprintf(nom,"../fic_%d_%d.cir",N,L);
	F = fopen(nom,"w");
	if (F == NULL) {perror("fopen"); exit(3);}
	fprintf(F,"%d %d\n",N,N);
	for (i=0;i<N;i++)
	{
		for (j=0;j<N;j++)
		{
			if (etat(N,L,i,j) == 0) fprintf(F,"#");
			if (etat(N,L,i,j) == 1) fprintf(F,".");
			if (etat(N,L,i,j) == 2) fprintf(F,"+");
		}
		fprintf(F,"\n");
	}
	fclose(F);
}

int usage(char *nom,int retour)
{
	fprintf(stderr,"usage: %s taille largeur\n",nom);
	fprintf(stderr,"       taille  > 10\n",nom);
	fprintf(stderr,"       largeur > 1\n",nom);
	exit(retour);
}

int main (int argc, char *argv[])
{
	int N,L;

	if (argc != 3) usage(argv[0],1);

	N = atoi(argv[1]);
	if (N<10) usage(argv[0],2);
	L = atoi(argv[2]);
	if (L<1) usage(argv[0],3);

	genere_fichier(N,L);
	exit (0);
}
